/// Generated By XFlutter Cli.
///
/// more info: https://medium.com/@aghiadodeh
///
/// state managment for UI
///
/// store and manage your liveData in [HomeParams].
import 'package:animated_infinite_scroll_pagination/animated_infinite_scroll_pagination.dart';
import 'package:flutter_mvvm_example/models/data/user/user.dart';
import 'package:flutter_mvvm_example/repositories/user_repository.dart';

import "home_params.dart";
import 'package:lazy_evaluation/lazy_evaluation.dart';

class HomeViewModel extends PaginationViewModel<User> {
  final _homeParams = Lazy(() => HomeParams());
  HomeParams get homeParams => _homeParams.value;

  final _repository = Lazy(() => UserRepository());
  UserRepository get repository => _repository.value;

  @override
  bool areItemsTheSame(User a, User b) {
    return a.id == b.id;
  }

  @override
  Future<void> fetchData(int page) async {
    final total = await repository.getUsersList(page);
    setTotal(total);
  }

  @override
  Stream<PaginationState<List<User>>> streamSubscription() {
    return repository.result;
  }
}
